# =============================================================
#                CodeTyphon Studio
#      Copyright (c) PilotLogic Software House.
#               All rights reserved.
# =============================================================

dothejob() 
{

echo "============================================================="
echo "            Build Lazarus32 Small IDE for $vosrealname"
echo "============================================================="

if [ ! -f $vfpcrundir/fpc$vbits ] ;
then    
    echo "[INFO]: FrePascal NOT exist, start FPC building..."
   ./ln_FPC32_Build.sh
fi

if [ ! -f $vlazlibdir/lazarus/Makefile.fpc ] ;
then    
   ./ln_Lazarus0_Exract_Source_from_ZipFile.sh
fi

# =================== Clear All Settings ===============================

./ln_Lazarus_Settings_Clear.sh

# =================== Prepare ==========================================

if [ ! -d $vlazlibdir/lazarus/bin$vbits ] ;
then   
  sudo mkdir $vlazlibdir/lazarus/bin$vbits
fi

./ln_Lazarus_Settings_Restore.sh

if [ -f $vlazlibdir/lazarus/bin$vbits/slazarus ] ;
then  
 sudo rm -f $vlazlibdir/lazarus/bin$vbits/slazarus
fi

if [ -f $vlazlibdir/lazarus/bin$vbits/bigide.txt ] ;
then  
 sudo rm -f $vlazlibdir/lazarus/bin$vbits/bigide.txt
fi

# =================== Build Lazarus32 ==================================

sudo chmod -R 777 $vlazlibdir/lazarus

cd $vlazlibdir/lazarus

if [ $vosname = solaris ] ;
then
$vmake clean all OPT="-Xn" PP=$vfpcexedir/$vfpcexec INSTALL_PREFIX=/usr/lib/codetyphon/lazarus/
else
$vmake clean all PP=$vfpcexedir/$vfpcexec INSTALL_PREFIX=/usr/lib/codetyphon/lazarus/
fi

# sleep 120

echo " "
echo "[FINAL INFO]: Strip executables..." 

cd $vlazlibdir/lazarus
sudo strip lazarus
sudo strip lazbuild
sudo strip startlazarus

# ================= Move Bin files ====================================

sudo mv -f lazarus $vlazlibdir/lazarus/bin$vbits/
sudo mv -f startlazarus $vlazlibdir/lazarus/bin$vbits/
sudo mv -f lazbuild $vlazlibdir/lazarus/bin$vbits/

sudo chmod -R 777 $vlazlibdir/lazarus
# sudo chmod -R 777 /usr/lib/codetyphon/lazarus/bin$vbits

# ================= Make links ====================================

echo "."
echo "[INFO]: make some links..."

sudo rm -f $vlazrundir/lazarus-ide$vbits
sudo rm -f $vlazrundir/lazbuild$vbits
sudo rm -f $vlazrundir/startlazarus$vbits

sudo ln -f -s $vlazlibdir/lazarus/bin$vbits/lazarus $vlazrundir/lazarus-ide$vbits
sudo ln -f -s $vlazlibdir/lazarus/bin$vbits/lazbuild $vlazrundir/lazbuild$vbits
sudo ln -f -s $vlazlibdir/lazarus/bin$vbits/startlazarus $vlazrundir/startlazarus$vbits
    
sudo cp -f ../bin/settings/$vname/lazarus$vbits.desktop $vappdskdir/
sudo cp -f ../bin/settings/$vname/lazarus$vbits.xml $vappxmldir/
sudo cp -f ../bin/settings/$vname/lazarus$vbits.png $vapppngdir/ 

sudo cp -f ../bin/settings/$vname/lazarus-ide.1.gz /usr/share/man/man1/
sudo cp -f ../bin/settings/$vname/lazbuild.1.gz /usr/share/man/man1/
sudo cp -f ../bin/settings/$vname/startlazarus.1.gz /usr/share/man/man1/

# ============================ Check Building =============================
echo " "
echo " ------------------------------------------------------"
echo " "
if [ ! -f $vlazlibdir/lazarus/bin$vbits/lazarus ] ;
then    
 echo  "??????????????????????????????????????????????????????"
 echo  "[ERROR]: Sorry, Lazarus32 Small IDE IDE NOT Build"
 echo  "??????????????????????????????????????????????????????"
 sleep 5
else
 echo "[FINAL INFO]: Lazarus32 Small IDE Build OK !!!" 
 echo " " 
 sleep 5
fi

}

# =================== MAIN ============================= 
. $PWD/ln_All_Functions.sh
getvalues

if [ $vbits = 32 ] ;
then 
 dothejob
fi

if [ $vsyslaz32sub = 1 ] ;
then 
  setdummy32
  dothejob 
fi




